version: '3'
services:
  app:
    image: app
    build: ./docker/app
    volumes:
      - '.:/app'
      - './docker/app/php.ini:/usr/local/etc/php/php.ini'
    depends_on:
      - mysql
      - redis
    command: /usr/local/sbin/php-fpm --allow-to-run-as-root
  front:
    image: caddy
    restart: unless-stopped
    ports:
      - '80:80'
      - '443:443'
    volumes:
      - './docker/caddy2/Caddyfile:/etc/caddy/Caddyfile'
      - '.:/app'
    depends_on:
      - app
    networks:
      default:
        aliases:
          - demo.zillion.design
          - demo.local
  mysql:
    image: 'mysql:8.0'
    command: '--max_allowed_packet=32505856 --default-authentication-plugin=mysql_native_password'
    environment:
      - MYSQL_ROOT_PASSWORD=secret
      - MYSQL_DATABASE=app
      - TZ=Europe/Kiev
    ports:
      - '33066:3306'
    volumes:
      - 'data:/data'
  redis:
    image: redis
    volumes:
      - 'data:/data'
    ports:
      - '63799:6379'
  scheduler:
    image: app
    build: ./docker/app
    volumes:
      - '.:/app'
      - './docker/app/php.ini:/usr/local/etc/php/php.ini'
    depends_on:
      - mysql
      - redis
    environment:
      - CONTAINER_ROLE=scheduler
    command: /usr/local/bin/start
  queue:
    image: app
    build: ./docker/app
    volumes:
      - '.:/app'
      - './docker/app/php.ini:/usr/local/etc/php/php.ini'
    depends_on:
      - mysql
      - redis
    environment:
      - CONTAINER_ROLE=queue
    command: /usr/local/bin/start
volumes:
  data: null
